<?php

use Phinx\Db\Adapter\MysqlAdapter;
use Phinx\Migration\AbstractMigration;

class AddAvoir extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("avoir_statut", ['id' => false, 'primary_key' => ["avoir_statut_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('avoir_statut_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('avoir_statut_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'avoir_statut_id'])
            ->create();

        $this
            ->table("avoir", ['id' => false, 'primary_key' => ["avoir_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('avoir_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'avoir_id', 'signed' => false])
            ->addColumn('avoir_montant', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'commande_id'])
            ->addColumn('avoir_raison', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'avoir_montant'])
            ->addColumn('avoir_paiement', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'avoir_raison'])
            ->addColumn('taxe_taux', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'avoir_paiement'])
            ->addColumn('avoir_commentaire', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'taxe_taux'])
            ->addColumn('avoir_statut_id', 'integer', ['null' => false, 'default' => '2', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'avoir_commentaire', 'signed' => false])
            ->addColumn('avoir_date_ajout', 'date', ['null' => false, 'default' => '0000-00-00', 'after' => 'avoir_statut_id'])
            ->addColumn('avoir_date_modif', 'datetime', ['null' => false, 'after' => 'avoir_date_ajout'])
            ->addColumn('client_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'avoir_date_modif', 'signed' => false])
            ->addColumn('avoir_date', 'date', ['null' => false, 'after' => 'client_id'])
            ->addForeignKey('commande_id', 'commande', 'commande_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('avoir_statut_id', 'avoir_statut', 'avoir_statut_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('client_id', 'client', 'client_id', array(
                'delete' => 'SET NULL',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_id'], ['name' => "commande_id", 'unique' => false])
            ->addIndex(['avoir_statut_id'], ['name' => "avoir_statut_id", 'unique' => false])
            ->addIndex(['client_id'], ['name' => "client_id", 'unique' => false])
            ->create();
    }
}
