<?php

namespace Console\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Command\Command;

/**
 * Class ExecuteMethod
 * @package Console\Command
 *
 * php dedi execute:method Controller\\ExportController exportXls
 */
class ExecuteMethod extends Command
{
    protected function configure()
    {
        $this
            ->setName('execute:method')
            ->setDescription('execute une methode d\'une classe')
            ->addArgument(
                'class',
                InputArgument::REQUIRED,
                'class name'
            )->addArgument(
                'method',
                InputArgument::REQUIRED,
                'method name'
            );
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $className = $input->getArgument('class');
        $result = call_user_func_array(array(new $className, $input->getArgument('method')), array());

        $output->writeln('<info>fin</info>');
    }

}