<?php

namespace DebugBar;

use Symfony\Component\EventDispatcher\Event;
use DebugBar\DataCollector\ConfigCollector;
use DebugBar\DataCollector\CartDataCollector;
use DebugBar\DataCollector\RouterDataCollector;
use DebugBar\DataCollector\MessagesCollector;

class DediDebugBar extends StandardDebugBar
{

    public function __construct()
    {
        parent::__construct();

        $this->addCollector(new MessagesCollector('sql'));
        $this->addCollector(new CartDataCollector());
        $this->addCollector(new RouterDataCollector());

    }

    public static function render()
    {

    }

    public function getJavascriptRenderer($baseUrl = null, $basePath = null)
    {
        if (is_null($baseUrl)) {
            $baseUrl = '/assets/debugbar';
        }

        $this->installAssets();
        return parent::getJavascriptRenderer($baseUrl, $basePath);
    }

    protected function installAssets()
    {

        // TODO : copy dir "/vendor/maximebf/debugbar/src/DebugBar/Resources" in "/web/assets/debugbar/"

        // $renderer = $this->getJavascriptRenderer();

        /*
        $assetsType = $this->getJavascriptRenderer()->getAssets();

        foreach ($assetsType as $key => $assets) {
            $dir = ($key == 0) ? 'css' : 'js';
            foreach ($assets as $asset) {
                $fileName = basename($asset);
                copy($asset, SITE_DIR . 'web' . DS . $dir . DS . $fileName);
            }
        }
        */
    }

    /**
     * @param Event $event
     * @throws DebugBarException
     */
    public function registerDataCollector(Event $event)
    {
        if (getenv('APP_DEBUG')) {
            $template = $event->getEngine();

            $this->addCollector(new ConfigCollector($template->getTemplateVars(), 'smarty'));

            $template->assign('debugbarRenderer', $this->getJavascriptRenderer());
        }
    }
}
